clc
clear all
% Initial/BC
%%%%%%%%%%%%%%%%%%%%%
He=50; %meter head
Q=0.325; %350 l/s
diam_o=0.34; %outer diameter rotor

n=0.786; %measured efficiency
T_c=30.5; %Max torque blade span
span=5; % Number of spans
T_b=T_c*span;
blades=24; %number of blades
h_f_diam=0.14764; %hydrolic force diameter

Tt=1596;
% Forces turbine
%%%%%%%%%%%%%%%%%%%%%
rot_rpm=(40*sqrt(He))/diam_o;
rot_rad=rot_rpm*2*pi/60; %rad/sec
period=60/(rot_rpm);%sec per rotation

power=n*9.81*1000*He*Q; %power to shaft
T_theory=power/rot_rad;

% Torque distribution channels
T_P1=T_c*span;
T_V1=0.25*T_P1;
T_P2=0.75*T_P1;
T_V2=T_V1;
blade1=0.05*T_P1;


P1=0.05/0.175; %peak 1
V1=0.08/0.175; %valley 1
P2=0.1/0.175; %peak 2
V2=0.125/0.175;
ant_P1=round(P1*blades);
ant_V1=round(V1*blades);
ant_P2=round(P2*blades);
ant_V2=round(V2*blades);

interval=period/24;

T=zeros(2,blades);
a=0;
Tot_torque=sum(T(1,:));

while abs(Tt-Tot_torque)>0.5

for i=2:1:blades;

    T(1,1)=blade1;
    T(2,1)=1;
    if  i<ant_P1;
        T(1,i)=a+(i-1)*(T_P1)/ant_P1;  
    elseif i==ant_P1;
        T(1,ant_P1)=T_P1;
    elseif i>ant_P1 && i<ant_V1;
        T(1,i)=T_P1+((T_V1-T_P1)/(ant_V1-ant_P1))*(i-ant_P1);
    elseif i==ant_V1;
        T(1,ant_V1)=T_V1;
    elseif i>ant_V1 && i<ant_P2;
        T(1,i)=T_V1+((T_P2-T_V1)/(ant_P2-ant_V1))*(i-ant_V1);
    elseif i==ant_P2;
        T(1,ant_P2)=T_P2;
    elseif i>ant_P2 && i<ant_V2
         T(1,i)=T_P2+((T_V2-T_P2)/(ant_V2-ant_P2))*(i-ant_P2);     
    elseif i==ant_V2;
        T(1,ant_V2)=T_V2;
    elseif i>ant_V2
         T(1,i)=T_V2+((a-T_V2)/(blades-ant_V2))*(i-ant_V2);
    end
    
    T(2,i)=i;
    Tot_torque=sum(T(1,:));    
end
    if abs(Tt-Tot_torque)>10;
        T_P1=T_P1+0.5*sign(Tt-Tot_torque);
    else
        T_P1=T_P1+0.05*sign(Tt-Tot_torque);
    end

    T_V1=0.25*T_P1;
    T_P2=0.75*T_P1;
    T_V2=0.15*T_P1;
end

x=T(2,:);
y=T(1,:);

clf


bar(x',y');

ylim([0 T_P1*1.1])
xlim([0.5 24.5])

xlabel('Blade nr')
ylabel('Torque [Nm]')
title('Torque distribution on blades')

